import { AD_REPOSITORY } from '@modules/ad/ad.di-tokens';
import { Inject } from '@nestjs/common';
import { CommandHandler, ICommandHandler } from '@nestjs/cqrs';
import { AdRepositoryPort } from '../../ports/ad.repository.port';
import { PauseAdCommand } from './pause-ad.command';

@CommandHandler(PauseAdCommand)
export class PauseAdService implements ICommandHandler {
  constructor(
    @Inject(AD_REPOSITORY)
    private readonly adRepository: AdRepositoryPort,
  ) {}

  async execute(command: PauseAdCommand): Promise<void> {
    const ad = await this.adRepository.findOneById(command.id);
    ad.pause();
    await this.adRepository.update(ad.id, ad);
  }
}
