import { MessagePublisherPort } from '@mobicoop/ddd-library';
import { AD_MESSAGE_PUBLISHER } from '@modules/ad/ad.di-tokens';
import { Inject, Injectable } from '@nestjs/common';
import { OnEvent } from '@nestjs/event-emitter';
import { AD_PAUSED_ROUTING_KEY } from '@src/app.constants';
import { AdPausedDomainEvent } from '../../domain/events/ad-paused.domain-event';

@Injectable()
export class PublishMessageWhenAdIsPausedDomainEventHandler {
  constructor(
    @Inject(AD_MESSAGE_PUBLISHER)
    private readonly messagePublisher: MessagePublisherPort,
  ) {}

  @OnEvent(AdPausedDomainEvent.name, { async: true, promisify: true })
  async handle(event: AdPausedDomainEvent): Promise<void> {
    this.messagePublisher.publish(AD_PAUSED_ROUTING_KEY, JSON.stringify(event));
  }
}
